P5180 支配树 题解
广告:同步于我的博客园 Charlie-Vinnie ,食用效果更佳
支配树:在 O(n\log n) 时间内求出一张有向图中能切断一个点到起点的所有路径的点
具体地,先定义一个起点
一个很重要的性质:对于任意点
求支配树的方法:
1. DAG 上求支配树
按照拓扑序枚举所有点,对于一个点
注意我们需要“动态”求这个 LCA,这问题不大,我们只需要每找到一个 fa[u][i] 即可。时间复杂度就
2. 一般图上求支配树
我们发现在 DAG 上很好做,考虑将一般图鼓捣成一个 DAG 且支配关系不变。
用著名的 Tarjan 思想,我们先搜出一棵 dfs 树再说。立即发现一个点
接下来,引入一个大家初学 Tarjan 就熟知的定理:对于有向图的 dfs 树而言,只存在前向边与反向边,不存在横叉边。 即只有祖先向孙子连边或孙子向祖先连边。
同样 DAG 部分,这次我们按dfs序逆序对每个点
-
此时 $v$ 能一步走到 $u$,所以从 $v$ 到 $u$ 的路径上所有其它点都不可能成为 $u$ 的支配点(否则压根切不断),所以 $u$ 的真实**支配点**应该在 $v$ **上方**,故用 $v$ 更新 $u$ 的**半支配点**。(这里的更新指取 **dfs 序最小**的作为答案) -
此时我们考虑 $u$ 到 $v$ 的路径上所有点 $w$ 以及它们的**半支配点** $semi_w$,发现如果我们割的点在任意一个 $semi_w$ 下方,那么从根就可以走路径 $S\rightarrow semi_w\rightarrow w\rightarrow v\rightarrow u$ 到达 $u$,矛盾。因此用所有 $w$ 的**半支配点** $semi_w$ 更新 $u$ 的**半支配点** $semi_u$。 画个图理解一下: 
更新完毕后,我们就得到了每个点
于是我们只保留原 dfs 树中的边,将其它边统统删掉,然后对于每个
现在只剩下怎么快速对一个点
考虑维护每个点
总时间复杂度
上一个封装好的代码:(注意代码中 semi[u],所以必须在访问完一个
洛谷 P5180 【模板】支配树
#include <bits/stdc++.h>
#define For(i,a,b) for(int i=a;i<=b;i++)
#define Rev(i,a,b) for(int i=a;i>=b;i--)
#define Fin(file) freopen(file,"r",stdin)
#define Fout(file) freopen(file,"w",stdout)
using namespace std;
const int N=2e5+5; typedef long long ll;
class DominatorTree{
int n,dfn[N],raw[N],dfscnt,semi[N],fa[N],pa[N],ffa[N][18],dep[N],in[N];
vector<int> to[N],from[N],cp[N],cv[N];
void dfs(int u){
raw[dfn[u]=++dfscnt]=u; for(int v:to[u]) if(!dfn[v]) { cp[u].push_back(v); pa[v]=u; dfs(v); }
}
int getfa(int x){
if(x!=fa[x]) { int t=getfa(fa[x]); semi[x]=min(semi[x],semi[fa[x]]); fa[x]=t; } return fa[x];
}
int lca(int x,int y){
if(dep[x]<dep[y]) swap(x,y);
Rev(i,17,0) if(dep[ffa[x][i]]>=dep[y]) x=ffa[x][i];
if(x==y) return x;
Rev(i,17,0) if(ffa[x][i]!=ffa[y][i]) { x=ffa[x][i]; y=ffa[y][i]; }
return ffa[x][0];
}
public:
void init(int _n) { n=_n; }
void add_edge(int x,int y) { to[x].push_back(y); from[y].push_back(x); }
void solve(int* ans){
dfs(1); assert(dfscnt==n);
For(i,1,n) { fa[i]=i; semi[i]=dfn[i]; }
Rev(i,n,2){
int u=raw[i]; for(int w:from[u]) { getfa(w); semi[u]=min(semi[u],semi[w]); }
fa[u]=pa[u]; cp[raw[semi[u]]].push_back(u); // Must do it right now!
}
For(u,1,n) for(int v:cp[u]) { cv[v].push_back(u); in[v]++; }
static int q[N],h,t; h=t=0; q[t++]=1;
while(h<t){
int u=q[h++]; ans[u]=0;
for(int v:cv[u]) if(ans[u]==0) ans[u]=v; else ans[u]=lca(ans[u],v);
dep[u]=dep[ffa[u][0]=ans[u]]+1; For(i,1,17) ffa[u][i]=ffa[ffa[u][i-1]][i-1];
for(int v:cp[u]) if((--in[v])==0) q[t++]=v;
}
}
}T;
int n,m,ans[N],siz[N]; vector<int> son[N];
void dfs(int u) { siz[u]=1; for(int v:son[u]) { dfs(v); siz[u]+=siz[v]; } }
signed main(){
ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
cin>>n>>m; T.init(n); For(i,1,m) { int x,y; cin>>x>>y; T.add_edge(x,y); } T.solve(ans);
// For(i,1,n) cerr<<ans[i]<<' '; cerr<<endl;
For(i,2,n) son[ans[i]].push_back(i);
dfs(1); For(i,1,n) cout<<siz[i]<<' '; cout<<endl;
cerr<<"Time = "<<clock()<<" ms\n";
return 0;
}
// START TYPING IF YOU DON'T KNOW WHAT TO DO